package flashmo_101_3d_carousel_fla
{
   import adobe.utils.*;
   import caurina.transitions.*;
   import flash.accessibility.*;
   import flash.display.*;
   import flash.errors.*;
   import flash.events.*;
   import flash.external.*;
   import flash.filters.*;
   import flash.geom.*;
   import flash.media.*;
   import flash.net.*;
   import flash.printing.*;
   import flash.system.*;
   import flash.text.*;
   import flash.ui.*;
   import flash.utils.*;
   import flash.xml.*;
   import org.papervision3d.cameras.*;
   import org.papervision3d.materials.*;
   import org.papervision3d.objects.*;
   import org.papervision3d.scenes.*;
   
   public dynamic class MainTimeline extends MovieClip
   {
      public var description_list:*;
      
      public var left:SimpleButton;
      
      public var right:SimpleButton;
      
      public var title_list:*;
      
      public var tn_url:TextField;
      
      public var loader:URLLoader;
      
      public var tn_desc:TextField;
      
      public var total:Number;
      
      public var i:Number;
      
      public var tn_title:TextField;
      
      public var url_list:*;
      
      public var anglePer:Number;
      
      public var container:Sprite;
      
      public var current:Number;
      
      public var radius:Number;
      
      public var folder:String;
      
      public var dest:Number;
      
      public var scene:Scene3D;
      
      public var url_target_list:Array;
      
      public var cam:Camera3D;
      
      public var camera_distance:Number;
      
      public var filename_list:*;
      
      public var angleX:Number;
      
      public var go:SimpleButton;
      
      public var flashmo_xml:XML;
      
      public function MainTimeline()
      {
         super();
         addFrameScript(0,frame1);
      }
      
      public function visitURL(param1:Event) : void
      {
         navigateToURL(new URLRequest(url_list[current]),url_target_list[current]);
      }
      
      public function create_thumbnail(param1:Event) : void
      {
         var _loc2_:BitmapFileMaterial = null;
         var _loc3_:Plane = null;
         flashmo_xml = XML(param1.target.data);
         total = flashmo_xml.thumbnail.length();
         anglePer = Math.PI * 2 / total;
         i = 0;
         while(i < total)
         {
            url_list.push(flashmo_xml.thumbnail[i].@url.toString());
            url_target_list.push(flashmo_xml.thumbnail[i].@target.toString());
            title_list.push(flashmo_xml.thumbnail[i].@title.toString());
            description_list.push(flashmo_xml.thumbnail[i].@description.toString());
            _loc2_ = new BitmapFileMaterial(folder + flashmo_xml.thumbnail[i].@filename.toString());
            _loc2_.oneSide = false;
            _loc2_.smooth = true;
            _loc3_ = new Plane(_loc2_,140,105,2,2);
            scene.addChild(_loc3_);
            _loc3_.x = Math.cos(i * anglePer) * radius;
            _loc3_.z = Math.sin(i * anglePer) * radius;
            _loc3_.rotationY = -i * anglePer * (180 / Math.PI) + 270;
            ++i;
         }
         setCurrent(current);
      }
      
      internal function frame1() : *
      {
         container = new Sprite();
         container.x = 400;
         container.y = 120;
         addChild(container);
         scene = new MovieScene3D(container);
         cam = new Camera3D();
         cam.zoom = 6.5;
         cam.y = 150;
         tn_title.text = "";
         tn_desc.text = "";
         tn_url.text = "";
         radius = 480;
         angleX = 0;
         camera_distance = radius * 2;
         dest = 0;
         current = 0;
         filename_list = new Array();
         url_list = new Array();
         url_target_list = new Array();
         title_list = new Array();
         description_list = new Array();
         folder = "thumbnails/";
         flashmo_xml = new XML();
         loader = new URLLoader();
         loader.load(new URLRequest("flashmo_101_thumbnail_list.xml"));
         loader.addEventListener(Event.COMPLETE,create_thumbnail);
         left.addEventListener(MouseEvent.CLICK,moveLeft);
         right.addEventListener(MouseEvent.CLICK,moveRight);
         go.addEventListener(MouseEvent.CLICK,visitURL);
         this.addEventListener(Event.ENTER_FRAME,render);
      }
      
      public function moveLeft(param1:Event) : void
      {
         --dest;
         --current;
         if(current < 0)
         {
            current = total - 1;
         }
         Tweener.addTween(this,{
            "angleX":dest * anglePer,
            "time":0.8,
            "transition":"easeInOutQuart"
         });
         setCurrent(current);
      }
      
      public function render(param1:Event) : void
      {
         cam.x = Math.cos(angleX) * camera_distance;
         cam.z = Math.sin(angleX) * camera_distance;
         scene.renderCamera(cam);
      }
      
      public function setCurrent(param1:Number) : void
      {
         tn_title.text = title_list[param1];
         tn_desc.text = description_list[param1];
         tn_url.text = url_list[param1];
      }
      
      public function moveRight(param1:Event) : void
      {
         ++dest;
         ++current;
         if(current >= total)
         {
            current = 0;
         }
         Tweener.addTween(this,{
            "angleX":dest * anglePer,
            "time":0.8,
            "transition":"easeInOutQuart"
         });
         setCurrent(current);
      }
   }
}

